<?php
namespace Faturamento\Entities;

use Geral\Entities\Servclie;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;
use Geral\Util\Ambiente;

class Histservfatu extends Base\Histservfatu
{
    /**
     * @param $linhas
     * @param $cdservfili
     *
     * @return null
     */
    public static function insereHistorico($linhas, $cdservfili)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();

        $nrorg = Ambiente::getNrorg();
        foreach ($linhas as $registro) {
            /** @var  $servclie \Geral\Entities\Servclie */
            $servclie = Servclie::getObjectByWhere(
                'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?  AND CDCLIENTE = ?',
                array(
                    $registro['CDFILIAL'], $nrorg, $registro['CDSERVFILI'],
                    $registro['CDCLIENTE']
                )
            );


            $historico = new Histservfatu();

            if (empty($servclie)) {
                $historico->setCdcliente($registro['CDCLIENTE']);
                $historico->setCdfilial($registro['CDFILIAL']);
                $historico->setCdservfili($cdservfili);
                $historico->setDtsrvfatuhis(DateUtil::getDataAtual());
                $historico->setDtaltefathis(DateUtil::getDataAtual());
                $historico->setVrservfathis($registro['VRSERVFATU']);

                $historico->setDtinclusao(DateUtil::getDataAtual());
                $historico->setDtultatu(DateUtil::getDataAtual());
                $historico->setNrorg($nrorg);
                $historico->setNrorginclusao(Ambiente::getNrorg());
                $historico->setCdoperinclusao(Ambiente::getCdOperador());
                $historico->setNrorgultatu(Ambiente::getNrorg());
                $historico->setCdoperultatu(Ambiente::getCdOperador());
                $historico->persist();
            } else {
                //Pk's
                $historico->setCdcliente($servclie->getCdcliente());
                $historico->setCdfilial($servclie->getCdfilial());
                $historico->setCdservfili($servclie->getCdservfili());
                $historico->setDtsrvfatuhis($servclie->getDtservfatu());
                $historico->setDtaltefathis(DateUtil::getDataAtual());
                //Valores
                $historico->setVrservfathis($servclie->getVrservfatu());
                $historico->setVrfatuferhis($servclie->getVrservfatfer());
                $historico->setVrfatudomhis($servclie->getVrservfatdom());
                $historico->setVrfatuseghis($servclie->getVrservfatseg());
                $historico->setVrfatuterhis($servclie->getVrservfatter());
                $historico->setVrfatuquahis($servclie->getVrservfatqua());
                $historico->setVrfatuquihis($servclie->getVrservfatqui());
                $historico->setVrfatusexhis($servclie->getVrservfatsex());
                $historico->setVrfatusabhis($servclie->getVrservfatsab());
                $historico->setCdoperlogado(Ambiente::getCdOperador());
                //Auditoria
                $historico->setDtinclusao(DateUtil::getDataAtual());
                $historico->setDtultatu(DateUtil::getDataAtual());
                $historico->setNrorg($nrorg);
                $historico->setNrorginclusao(Ambiente::getNrorg());
                $historico->setCdoperinclusao(Ambiente::getCdOperador());
                $historico->setNrorgultatu(Ambiente::getNrorg());
                $historico->setCdoperultatu(Ambiente::getCdOperador());
                $historico->persist();
            }


        }
        $connection->flush();
        $connection->commit();
    }

    /**
     * @param $cdfilial
     * @param $cdservfili
     * @param $cdcliente
     *
     * @return null
     */
    public static function insereHistExcessao($cdfilial, $cdservfili, $cdcliente)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();

        $nrorg = Ambiente::getNrorg();

        /** @var  $servclie \Geral\Entities\Servclie */
        $servclie = Servclie::getObjectByWhere(
            'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?  AND CDCLIENTE = ?',
            array(
                $cdfilial, $nrorg, $cdservfili,
                $cdcliente
            )
        );
        $historico = new Histservfatu();
        //Pk's
        $historico->setCdcliente($servclie->getCdcliente());
        $historico->setCdfilial($servclie->getCdfilial());
        $historico->setCdservfili($servclie->getCdservfili());
        $historico->setDtsrvfatuhis($servclie->getDtservfatu());
        $historico->setDtaltefathis(DateUtil::getDataAtual());
        //Valores
        $historico->setVrservfathis($servclie->getVrservfatu());
        $historico->setVrfatuferhis($servclie->getVrservfatfer());
        $historico->setVrfatudomhis($servclie->getVrservfatdom());
        $historico->setVrfatuseghis($servclie->getVrservfatseg());
        $historico->setVrfatuterhis($servclie->getVrservfatter());
        $historico->setVrfatuquahis($servclie->getVrservfatqua());
        $historico->setVrfatuquihis($servclie->getVrservfatqui());
        $historico->setVrfatusexhis($servclie->getVrservfatsex());
        $historico->setVrfatusabhis($servclie->getVrservfatsab());
        $historico->setCdoperlogado(Ambiente::getCdOperador());
        //Auditoria
        $historico->setDtinclusao(DateUtil::getDataAtual());
        $historico->setDtultatu(DateUtil::getDataAtual());
        $historico->setNrorg($nrorg);
        $historico->setNrorginclusao(Ambiente::getNrorg());
        $historico->setCdoperinclusao(Ambiente::getCdOperador());
        $historico->setNrorgultatu(Ambiente::getNrorg());
        $historico->setCdoperultatu(Ambiente::getCdOperador());
        $historico->persist();

        $connection->flush();
        $connection->commit();
    }

    public static function retornaMaiorData($cdfilial, $cdservfili, $cdcliente)
    {
        $histservfatu = Histservfatu::getObjectByWhere('CDFILIAL = ? AND CDSERVFILI = ? AND CDCLIENTE = ? ORDER BY DTSRVFATUHIS DESC', array($cdfilial, $cdservfili, $cdcliente));

        return $histservfatu;

    }

}