create or replace
PROCEDURE IMPORTA_FILIAL_SAP
IS
   V_CDPAIS       INTEGER;
   V_SGESTADO     INTEGER;
   V_CDFILIAL     INTEGER;
   V_PAISC        INTEGER;
   V_ESTADOC      INTEGER;
   V_CDMUNICIPIO  VARCHAR2(4);
   V_CDMUNICIPIOC VARCHAR2(4);
   V_ENDEFILIC    INTEGER;
   V_INSCRMUNI    INTEGER;
   V_CDSERIE      VARCHAR2(10);
   V_EXISTSERIE   INTEGER;
   V_NMRAZSOCEMPR VARCHAR(80);
   V_IDENTRSAID  VARCHAR2(1);
   V_CDTIPOOPER  VARCHAR2(2);
   V_ERROR       VARCHAR2(300);
   
   CURSOR C_PARAM IS
      SELECT IDENTRSAIDOP, CDTIPOOPER
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'E';

BEGIN
   FOR C_FILIAL IN
       (SELECT U.CDFILIAL, U.NMFILIAL, U.CDEMPRESA, U.CDINSCESTA, U.CDINSCMUNI, U.DSENDERECOP, U.CDPAISP, U.SGESTADOP, U.CDMUNICIPIOP,
               U.CDCEPP, U.NMBAIRROP, U.EMAIL, U.DSENDERECOC, U.CDPAISC, U.SGESTADOC, U.CDMUNICIPIOC, U.CDCEPC, U.NMBAIRROC,
               U.NRINSJURFILI, U.IDINTERFACE, U.TPINTERFACE
          FROM USR_SAP_FILIAL U
         WHERE U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP
      SELECT COUNT(1) AS CDPAIS
        INTO V_CDPAIS
        FROM PAIS
       WHERE CDPAIS = C_FILIAL.CDPAISP;
      IF V_CDPAIS > 0 THEN
         SELECT COUNT(1) AS SGESTADO
           INTO V_SGESTADO
           FROM ESTADO
          WHERE CDPAIS   = C_FILIAL.CDPAISP
            AND SGESTADO = C_FILIAL.SGESTADOP;
         IF V_SGESTADO > 0 THEN
            BEGIN
               SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                 INTO V_CDMUNICIPIO
                 FROM MUNICIPIO
                WHERE CDPAIS      = C_FILIAL.CDPAISP
                  AND SGESTADO    = C_FILIAL.SGESTADOP
                  AND CDMUNICIBGE = C_FILIAL.CDMUNICIPIOP;
               IF V_CDMUNICIPIO IS NOT NULL THEN
                  BEGIN
                     SELECT COUNT(1) AS CDINSCMUNI, SUBSTR(NMRAZSOCEMPR, 1, 40) NMRAZSOCEMPR
                       INTO V_INSCRMUNI, V_NMRAZSOCEMPR
                       FROM INSCRMUNICIP I, EMPRESA E
                      WHERE I.CDEMPRESA  = E.CDEMPRESA
                        AND E.CDEMPRESA  = C_FILIAL.CDEMPRESA
                        AND I.CDINSCMUNI = C_FILIAL.CDINSCMUNI
                      GROUP BY NMRAZSOCEMPR;
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_INSCRMUNI := 0;
                  END;

               IF V_INSCRMUNI = 0 THEN
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'A inscri'||CHR(231)||''||CHR(231)||'o '||C_FILIAL.CDINSCMUNI||' no est relacionada a empresa '|| C_FILIAL.CDEMPRESA);

                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
--                  COMMIT;
               ELSE
                  SELECT COUNT(1) AS CDFILIAL
                    INTO V_CDFILIAL
                    FROM FILIAL
                   WHERE CDFILIAL = C_FILIAL.CDFILIAL;
                  IF V_CDFILIAL = 0 THEN
                     /* Filial */
                     INSERT INTO FILIAL(CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRINSJURFILI, NMRAZSOCFILI)
                     VALUES (C_FILIAL.CDFILIAL, C_FILIAL.NMFILIAL, C_FILIAL.CDEMPRESA, C_FILIAL.CDINSCESTA, C_FILIAL.CDINSCMUNI, C_FILIAL.NRINSJURFILI, V_NMRAZSOCEMPR);
                     /* Endereo principal */
                     INSERT INTO ENDEFILI(CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI,
                                          NMBAIRFILI, DSEMAILFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                     VALUES (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOP, C_FILIAL.CDPAISP, C_FILIAL.SGESTADOP, V_CDMUNICIPIO, C_FILIAL.CDCEPP,
                             C_FILIAL.NMBAIRROP, C_FILIAL.EMAIL, 'P', 'N', 'N');


                     INSERT INTO PARAMFILIAL
                        (CDFILIAL, IDCTRLESTQ)
                     VALUES
                        (C_FILIAL.CDFILIAL, 'N');

                     INSERT INTO ALMOXARIFADO
                    (CDFILIAL, CDALMOXARIFE, DSALMOXARIFE)
                     (SELECT C_FILIAL.CDFILIAL, ' ', ' '
                        FROM PARAMGERAL
                       MINUS
                      SELECT CDFILIAL, CDALMOXARIFE, DSALMOXARIFE
                        FROM ALMOXARIFADO
                       WHERE CDFILIAL = C_FILIAL.CDFILIAL
                         AND CDALMOXARIFE = ' ');

                      INSERT INTO PARAMFILIPADR
                      (CDFILIAL, NMTABPARAMFILI)
                      (SELECT C_FILIAL.CDFILIAL, NMTABPARAMFILI
                         FROM (SELECT 'ALMOXARIFADO' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'LOCALESTOQUE' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'PARAMFILIAL' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'PARAMPEDIDO' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'PARAMPLANEJA' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'PARCMPSUP' AS NMTABPARAMFILI
                                 FROM DUAL
                                UNION
                               SELECT 'PAREXPEDICAO' AS NMTABPARAMFILI
                                 FROM DUAL
                              ) A
                        WHERE NOT EXISTS(SELECT 1
                                           FROM PARAMFILIPADR PF
                                          WHERE PF.CDFILIAL       = C_FILIAL.CDFILIAL
                                            AND PF.NMTABPARAMFILI = A.NMTABPARAMFILI));
                        BEGIN
                           OPEN C_PARAM;
                           LOOP
                              FETCH C_PARAM INTO V_IDENTRSAID, V_CDTIPOOPER;
                              EXIT WHEN C_PARAM%NOTFOUND;

                              INSERT INTO PARAMBLOQNFAFIL(CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDLIBERATPOPFIL, IDEXIGEAF, IDVALIDINSXML)
                              VALUES(C_FILIAL.CDFILIAL, V_IDENTRSAID, V_CDTIPOOPER, 'N', 'N', 'S');
                           END LOOP;

                           CLOSE C_PARAM;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_ERROR := SQLERRM(SQLCODE);

                              INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                              VALUES(C_FILIAL.IDINTERFACE, 'I', 1, SYSDATE, 0, 'Erro ao incluir bloqueio tipo operao por filial, para a filial '||C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||'. Erro: ' ||V_ERROR);

                              CLOSE C_PARAM;
                         END;

                     /* LOG */
                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 0, 'Filial '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||' cadastrada com sucesso.');
                     /* Atualiza registro pra no ser importado de novo  */
                     UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                      WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
--                     COMMIT;
                     /* Endereo de cobrana  */
                     SELECT COUNT(1) AS CDPAIS 
                       INTO V_PAISC
                       FROM PAIS
                      WHERE CDPAIS = C_FILIAL.CDPAISC;
                     IF V_PAISC > 0 THEN
                        SELECT COUNT(1) AS SGESTADO
                          INTO V_ESTADOC
                          FROM ESTADO
                         WHERE CDPAIS   = C_FILIAL.CDPAISC
                           AND SGESTADO = C_FILIAL.SGESTADOC;
                        IF V_ESTADOC > 0 THEN
                           BEGIN
                              SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                                INTO V_CDMUNICIPIOC
                                FROM MUNICIPIO
                               WHERE CDPAIS      = C_FILIAL.CDPAISC
                                 AND SGESTADO    = C_FILIAL.SGESTADOC
                                 AND CDMUNICIBGE = C_FILIAL.CDMUNICIPIOC;
                              IF V_CDMUNICIPIOC IS NOT NULL THEN
                                 INSERT INTO ENDEFILI(CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI, 
                                                      NMBAIRFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                                 VALUES (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOC, C_FILIAL.CDPAISC, C_FILIAL.SGESTADOC, V_CDMUNICIPIOC, C_FILIAL.CDCEPC, 
                                         C_FILIAL.NMBAIRROC, 'C', 'N', 'N');
                              ELSE
                                 V_CDMUNICIPIOC := '';
                                 INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '||C_FILIAL.CDMUNICIPIOC ||', relacionado a cobran'||CHR(231)||'a da filial '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', n'||CHR(227)||'o cadastrado no sistema Teknisa');
                                 /* Atualiza registro pra que o mesmo possa ser importado aps correo.  */
                                 UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                  WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
--                                 COMMIT;
                              END IF;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
--                                 ROLLBACK; 
                                 V_CDMUNICIPIOC := '';
                                 INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '||C_FILIAL.CDMUNICIPIOC ||', relacionado a cobran'||CHR(231)||'a da filial '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', n'||CHR(227)||'o cadastrado no sistema Teknisa');
                                 /* Atualiza registro pra que o mesmo possa ser importado aps correo.  */
                                 UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                  WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
--                                 COMMIT;
                           END;
                        END IF;
                     END IF;
                  ELSE
                     BEGIN
                        SELECT NVL(CDSERIE, '0000000000')
                          INTO V_CDSERIE
                          FROM FILIAL
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL;
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_CDSERIE := '0000000000';
                     END;
                     
                     IF V_CDSERIE != '0000000000' THEN
                        SELECT COUNT(1)
                          INTO V_EXISTSERIE
                          FROM SERIENF
                         WHERE CDEMPRESA  = C_FILIAL.CDEMPRESA
                           AND CDINSCMUNI = C_FILIAL.CDINSCMUNI
                           AND CDINSCESTA = C_FILIAL.CDINSCESTA
                           AND CDSERIE    = V_CDSERIE;
                     ELSE
                        V_EXISTSERIE := 1;
                     END IF;
                     
                     IF V_EXISTSERIE > 0 THEN
                        UPDATE FILIAL 
                           SET NMFILIAL = C_FILIAL.NMFILIAL, NRINSJURFILI = C_FILIAL.NRINSJURFILI,
                               CDEMPRESA = C_FILIAL.CDEMPRESA, CDINSCESTA = C_FILIAL.CDINSCESTA,
                               CDINSCMUNI = C_FILIAL.CDINSCMUNI, NMRAZSOCFILI = V_NMRAZSOCEMPR
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL;
                        UPDATE ENDEFILI SET DSENDEFILI = C_FILIAL.DSENDERECOP, CDPAIS = C_FILIAL.CDPAISP, SGESTADO = C_FILIAL.SGESTADOP,
                                            CDMUNICIPIO = V_CDMUNICIPIO, NRCEPFILI = C_FILIAL.CDCEPP, NMBAIRFILI = C_FILIAL.NMBAIRROP,
                                            DSEMAILFILI = C_FILIAL.EMAIL
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL
                           AND IDTPENDEFILI = 'P';
                        SELECT COUNT(1) AS CDPAIS 
                          INTO V_PAISC
                          FROM PAIS
                         WHERE CDPAIS = C_FILIAL.CDPAISC;
                        IF V_PAISC > 0 THEN
                           SELECT COUNT(1) AS SGESTADO
                             INTO V_ESTADOC
                             FROM ESTADO
                            WHERE CDPAIS   = C_FILIAL.CDPAISC
                              AND SGESTADO = C_FILIAL.SGESTADOC;
                           IF V_ESTADOC > 0 THEN
                              BEGIN
                                 SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                                   INTO V_CDMUNICIPIOC
                                   FROM MUNICIPIO
                                  WHERE CDPAIS      = C_FILIAL.CDPAISC
                                    AND SGESTADO    = C_FILIAL.SGESTADOC
                                    AND CDMUNICIBGE = C_FILIAL.CDMUNICIPIOC;
                                 IF V_CDMUNICIPIOC IS NOT NULL THEN
                                    SELECT COUNT(1) 
                                      INTO V_ENDEFILIC
                                      FROM ENDEFILI
                                     WHERE CDFILIAL = C_FILIAL.CDFILIAL
                                       AND IDTPENDEFILI = 'C';
                                    IF V_ENDEFILIC > 0 THEN
                                       UPDATE ENDEFILI SET DSENDEFILI = C_FILIAL.DSENDERECOC, CDPAIS = C_FILIAL.CDPAISC, SGESTADO = C_FILIAL.SGESTADOC,
                                                           CDMUNICIPIO = V_CDMUNICIPIOC, NRCEPFILI = C_FILIAL.CDCEPC, NMBAIRFILI = C_FILIAL.NMBAIRROC, 
                                                           DSEMAILFILI = C_FILIAL.EMAIL
                                        WHERE CDFILIAL = C_FILIAL.CDFILIAL
                                          AND IDTPENDEFILI = 'C';
                                    ELSE
                                       INSERT INTO ENDEFILI(CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI, 
                                                            NMBAIRFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                                       VALUES (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOC, C_FILIAL.CDPAISC, C_FILIAL.SGESTADOC, V_CDMUNICIPIOC, C_FILIAL.CDCEPC, 
                                               C_FILIAL.NMBAIRROC, 'C', 'N', 'N');
                                    END IF;
                                    UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                                     WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
   --                                 COMMIT;
                                 END IF;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_CDMUNICIPIOC := '';
                                    INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                    VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '||C_FILIAL.CDMUNICIPIOC ||', relacionado a cobran'||CHR(231)||'a da filial '|| C_FILIAL.CDFILIAL|| ' - ' || C_FILIAL.NMFILIAL ||', n'||CHR(227)||'o cadastrado no sistema Teknisa');

                                    UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                     WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
   --                                 COMMIT;
                              END;   
                           END IF;
                        END IF;
                        INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES (C_FILIAL.IDINTERFACE, 'A', 3, SYSDATE, 0, 'Atualiza'||CHR(231)||CHR(227)||'o da filial '||C_FILIAL.CDFILIAL ||' realizada com sucesso.');

                        UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                         WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                     ELSE
                        INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'N'||CHR(227)||'o foi possivel realizar a atualiza'||CHR(231)||CHR(227)||'o da filial '|| C_FILIAL.CDFILIAL ||', pois a s'||CHR(233)||'rie '|| V_CDSERIE ||' n'||CHR(227)||'o se encontra vinculada a inscri'||CHR(231)||CHR(227)||'o');
                        
                        UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                         WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                     END IF; 
                  END IF;
               END IF;
               ELSE
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '||C_FILIAL.CDMUNICIPIOP || ', relacionado ao endereo principal da filial ' || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL || ', n'|| CHR(227) || 'o cadastrado no sistema Teknisa');
                  
                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
--                  COMMIT;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '||C_FILIAL.CDMUNICIPIOP || ', relacionado ao endereo principal da filial ' || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL || ', n'|| CHR(227) || 'o cadastrado no sistema Teknisa');
                  
                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
--                  COMMIT;
            END;
         ELSE
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'Sigla do estado '|| C_FILIAL.SGESTADOP || ',relacionado a filial '  || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL || ', n'||CHR(227)||'o cadastrada no sistema Teknisa');

            UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
             WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;

         END IF;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||C_FILIAL.CDPAISP || ',relacionado a filial '  || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||  ', n'||CHR(227)||'o cadastrado no sistema Teknisa');

         UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
          WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_FILIAL_SAP','6.25.XXX'); END;
/
