/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */                                            /* Nome: DTULTATU_FAMSALDOPROD                                                */
/* Criao:                                                                   */
/* 10/05/2006 - Leonardo A. R. de Matos                                       */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FAMSALDOPROD'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_FAMSALDOPROD
  GO

CREATE TRIGGER DTULTATU_FAMSALDOPROD
ON FAMSALDOPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FAMSALDOPROD',DELETED.CDFILIAL, 'CDFILIAL='+DELETED.CDFILIAL+';'+'CDFAMILISALD='+DELETED.CDFAMILISALD+';'+'CDPRODUTO='+DELETED.CDPRODUTO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FAMSALDOPROD
      SET DTULTATUFSPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(FAMSALDOPROD.CDFILIAL      ,0) = ISNULL(INSERTED.CDFILIAL      ,0)) AND
            (ISNULL(FAMSALDOPROD.CDFAMILISALD  ,0) = ISNULL(INSERTED.CDFAMILISALD  ,0)) AND
            (ISNULL(FAMSALDOPROD.QTCONSDIAFAM  ,0) = ISNULL(INSERTED.QTCONSDIAFAM  ,0)) AND
            (ISNULL(FAMSALDOPROD.CDPRODUTO     ,0) = ISNULL(INSERTED.CDPRODUTO     ,0)) AND
		(ISNULL(FAMSALDOPROD.IDPERMREFEXTRA,0) = ISNULL(INSERTED.IDPERMREFEXTRA,0));
   END;
END;
GO

UPDATE FAMSALDOPROD SET DTULTATUFSPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUFSPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUFSPR' and
            type = 'D')
   ALTER TABLE FAMSALDOPROD DROP CONSTRAINT DEFAULT_DTULTATUFSPR
GO

ALTER TABLE FAMSALDOPROD ADD CONSTRAINT DEFAULT_DTULTATUFSPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUFSPR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FAMSALDOPROD','4.11.194';
GO

